From 99c32c8bb1d424aecdf24fcb0e96a470c91d83a0 Mon Sep 17 00:00:00 2001
From: "dgrowley@gmail.com" <dgrowley@gmail.com>
Date: Thu, 2 Aug 2018 16:02:42 +1200
Subject: [PATCH v1 2/4] Store partition details in pg_partition instead of
 pg_inherits

---
 contrib/postgres_fdw/postgres_fdw.c        |   4 +-
 src/backend/catalog/Makefile               |   2 +-
 src/backend/catalog/heap.c                 |  72 ++---
 src/backend/catalog/index.c                |   2 +-
 src/backend/catalog/partition.c            | 140 +++++----
 src/backend/catalog/pg_inherits.c          |   6 +
 src/backend/commands/analyze.c             |  12 +-
 src/backend/commands/lockcmds.c            | 127 +++++---
 src/backend/commands/publicationcmds.c     |  10 +-
 src/backend/commands/tablecmds.c           | 477 +++++++++++++++++++++--------
 src/backend/commands/trigger.c             |  10 +-
 src/backend/commands/vacuum.c              |   3 +-
 src/backend/executor/execPartition.c       |   3 +-
 src/backend/optimizer/prep/prepunion.c     | 215 ++++++++-----
 src/backend/partitioning/partbounds.c      |  11 +-
 src/backend/rewrite/rewriteDefine.c        |   2 +-
 src/backend/tcop/utility.c                 |   9 +-
 src/backend/utils/cache/partcache.c        |  70 +++--
 src/backend/utils/cache/syscache.c         |  14 +-
 src/bin/pg_dump/common.c                   |  22 ++
 src/bin/pg_dump/pg_dump.c                  |  30 +-
 src/bin/pg_dump/pg_dump.h                  |   1 +
 src/bin/psql/describe.c                    |  60 +++-
 src/bin/psql/tab-complete.c                |   1 +
 src/include/catalog/heap.h                 |   4 +-
 src/include/catalog/indexing.h             |   6 +
 src/include/catalog/partition.h            |   2 +
 src/include/catalog/pg_class.dat           |  18 +-
 src/include/catalog/pg_class.h             |   3 +-
 src/include/catalog/toasting.h             |   1 +
 src/include/nodes/parsenodes.h             |   2 +-
 src/include/utils/rel.h                    |   6 +
 src/include/utils/syscache.h               |   1 +
 src/test/regress/expected/alter_table.out  |   4 +-
 src/test/regress/expected/misc_sanity.out  |   3 +-
 src/test/regress/expected/sanity_check.out |   1 +
 36 files changed, 907 insertions(+), 447 deletions(-)

diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index 0803c30a48..beb867d613 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -4522,7 +4522,9 @@ postgresImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid)
 		deparseStringLiteral(&buf, stmt->remote_schema);
 
 		/* Partitions are supported since Postgres 10 */
-		if (PQserverVersion(conn) >= 100000)
+		if (PQserverVersion(conn) >= 120000)
+			appendStringInfoString(&buf, " AND c.relpartitionparent <> 0 ");
+		else if (PQserverVersion(conn) >= 100000)
 			appendStringInfoString(&buf, " AND NOT c.relispartition ");
 
 		/* Apply restrictions for LIMIT TO and EXCEPT */
diff --git a/src/backend/catalog/Makefile b/src/backend/catalog/Makefile
index 0865240f11..43d9e2eaaa 100644
--- a/src/backend/catalog/Makefile
+++ b/src/backend/catalog/Makefile
@@ -46,7 +46,7 @@ CATALOG_HEADERS := \
 	pg_default_acl.h pg_init_privs.h pg_seclabel.h pg_shseclabel.h \
 	pg_collation.h pg_partitioned_table.h pg_range.h pg_transform.h \
 	pg_sequence.h pg_publication.h pg_publication_rel.h pg_subscription.h \
-	pg_subscription_rel.h
+	pg_subscription_rel.h pg_partition.h
 
 GENERATED_HEADERS := $(CATALOG_HEADERS:%.h=%_d.h) schemapg.h
 
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index 4cfc0c8911..c6429a3785 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -49,6 +49,7 @@
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_opclass.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_partitioned_table.h"
 #include "catalog/pg_statistic.h"
 #include "catalog/pg_subscription_rel.h"
@@ -810,7 +811,7 @@ InsertPgClassTuple(Relation pg_class_desc,
 	values[Anum_pg_class_relhassubclass - 1] = BoolGetDatum(rd_rel->relhassubclass);
 	values[Anum_pg_class_relispopulated - 1] = BoolGetDatum(rd_rel->relispopulated);
 	values[Anum_pg_class_relreplident - 1] = CharGetDatum(rd_rel->relreplident);
-	values[Anum_pg_class_relispartition - 1] = BoolGetDatum(rd_rel->relispartition);
+	values[Anum_pg_class_relpartitionparent - 1] = ObjectIdGetDatum(rd_rel->relpartitionparent);
 	values[Anum_pg_class_relrewrite - 1] = ObjectIdGetDatum(rd_rel->relrewrite);
 	values[Anum_pg_class_relfrozenxid - 1] = TransactionIdGetDatum(rd_rel->relfrozenxid);
 	values[Anum_pg_class_relminmxid - 1] = MultiXactIdGetDatum(rd_rel->relminmxid);
@@ -823,9 +824,6 @@ InsertPgClassTuple(Relation pg_class_desc,
 	else
 		nulls[Anum_pg_class_reloptions - 1] = true;
 
-	/* relpartbound is set by updating this tuple, if necessary */
-	nulls[Anum_pg_class_relpartbound - 1] = true;
-
 	tup = heap_form_tuple(RelationGetDescr(pg_class_desc), values, nulls);
 
 	/*
@@ -929,8 +927,8 @@ AddNewRelationTuple(Relation pg_class_desc,
 	new_rel_reltup->reltype = new_type_oid;
 	new_rel_reltup->reloftype = reloftype;
 
-	/* relispartition is always set by updating this tuple later */
-	new_rel_reltup->relispartition = false;
+	/* relpartitionparent is always set by updating this tuple later */
+	new_rel_reltup->relpartitionparent = InvalidOid;
 
 	new_rel_desc->rd_att->tdtypeid = new_type_oid;
 
@@ -1807,11 +1805,17 @@ heap_drop_with_catalog(Oid relid)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	if (((Form_pg_class) GETSTRUCT(tuple))->relispartition)
+
+	parentOid = ((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent;
+	if (OidIsValid(parentOid))
 	{
-		parentOid = get_partition_parent(relid);
+		HeapTuple parttup;
+		Relation	pgpart;
+
 		LockRelationOid(parentOid, AccessExclusiveLock);
 
+		pgpart =  heap_open(PartitionRelationId, RowExclusiveLock);
+
 		/*
 		 * If this is not the default partition, dropping it will change the
 		 * default partition's partition constraint, so we must lock it.
@@ -1819,6 +1823,14 @@ heap_drop_with_catalog(Oid relid)
 		defaultPartOid = get_default_partition_oid(parentOid);
 		if (OidIsValid(defaultPartOid) && relid != defaultPartOid)
 			LockRelationOid(defaultPartOid, AccessExclusiveLock);
+
+		parttup = SearchSysCacheCopy1(PARTSRELID, ObjectIdGetDatum(relid));
+		if (!HeapTupleIsValid(parttup))
+			elog(ERROR, "cache lookup failed for relation %u", relid);
+
+		CatalogTupleDelete(pgpart, &parttup->t_self);
+
+		heap_close(pgpart, RowExclusiveLock);
 	}
 
 	ReleaseSysCache(tuple);
@@ -2759,7 +2771,8 @@ MergeWithExistingConstraint(Relation rel, const char *ccname, Node *expr,
 			 * constraints are always non-local, including those that were
 			 * merged.
 			 */
-			if (is_local && !con->conislocal && !rel->rd_rel->relispartition)
+			if (is_local && !con->conislocal &&
+				!OidIsValid(rel->rd_rel->relpartitionparent))
 				allow_merge = true;
 
 			if (!found || !allow_merge)
@@ -2809,7 +2822,7 @@ MergeWithExistingConstraint(Relation rel, const char *ccname, Node *expr,
 			 * inherited only once since it cannot have multiple parents and
 			 * it is never considered local.
 			 */
-			if (rel->rd_rel->relispartition)
+			if (OidIsValid(rel->rd_rel->relpartitionparent))
 			{
 				con->coninhcount = 1;
 				con->conislocal = false;
@@ -3481,9 +3494,9 @@ RemovePartitionKeyByRelId(Oid relid)
 }
 
 /*
- * StorePartitionBound
- *		Update pg_class tuple of rel to store the partition bound and set
- *		relispartition to true
+ * MarkRelationPartitioned
+ *		Update pg_class tuple of rel to set relpartitionparent to the parent's
+ *		Oid.
  *
  * If this is the default partition, also update the default partition OID in
  * pg_partitioned_table.
@@ -3493,14 +3506,10 @@ RemovePartitionKeyByRelId(Oid relid)
  * default partition, we must invalidate its relcache entry as well.
  */
 void
-StorePartitionBound(Relation rel, Relation parent, PartitionBoundSpec *bound)
+MarkRelationPartitioned(Relation rel, Relation parent, bool is_default)
 {
 	Relation	classRel;
-	HeapTuple	tuple,
-				newtuple;
-	Datum		new_val[Natts_pg_class];
-	bool		new_null[Natts_pg_class],
-				new_repl[Natts_pg_class];
+	HeapTuple	tuple;
 	Oid			defaultPartOid;
 
 	/* Update pg_class tuple */
@@ -3514,36 +3523,23 @@ StorePartitionBound(Relation rel, Relation parent, PartitionBoundSpec *bound)
 #ifdef USE_ASSERT_CHECKING
 	{
 		Form_pg_class classForm;
-		bool		isnull;
 
 		classForm = (Form_pg_class) GETSTRUCT(tuple);
-		Assert(!classForm->relispartition);
-		(void) SysCacheGetAttr(RELOID, tuple, Anum_pg_class_relpartbound,
-							   &isnull);
-		Assert(isnull);
+		Assert(!OidIsValid(classForm->relpartitionparent));
 	}
 #endif
 
-	/* Fill in relpartbound value */
-	memset(new_val, 0, sizeof(new_val));
-	memset(new_null, false, sizeof(new_null));
-	memset(new_repl, false, sizeof(new_repl));
-	new_val[Anum_pg_class_relpartbound - 1] = CStringGetTextDatum(nodeToString(bound));
-	new_null[Anum_pg_class_relpartbound - 1] = false;
-	new_repl[Anum_pg_class_relpartbound - 1] = true;
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(classRel),
-								 new_val, new_null, new_repl);
-	/* Also set the flag */
-	((Form_pg_class) GETSTRUCT(newtuple))->relispartition = true;
-	CatalogTupleUpdate(classRel, &newtuple->t_self, newtuple);
-	heap_freetuple(newtuple);
+	/* Set the relpartitionparent */
+	((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent = RelationGetRelid(parent);
+	CatalogTupleUpdate(classRel, &tuple->t_self, tuple);
+	heap_freetuple(tuple);
 	heap_close(classRel, RowExclusiveLock);
 
 	/*
 	 * If we're storing bounds for the default partition, update
 	 * pg_partitioned_table too.
 	 */
-	if (bound->is_default)
+	if (is_default)
 		update_default_partition_oid(RelationGetRelid(parent),
 									 RelationGetRelid(rel));
 
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index 8b276bc430..eda850edef 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -936,7 +936,7 @@ index_create(Relation heapRelation,
 	indexRelation->rd_rel->relowner = heapRelation->rd_rel->relowner;
 	indexRelation->rd_rel->relam = accessMethodObjectId;
 	indexRelation->rd_rel->relhasoids = false;
-	indexRelation->rd_rel->relispartition = OidIsValid(parentIndexRelid);
+	indexRelation->rd_rel->relpartitionparent = parentIndexRelid;
 
 	/*
 	 * store index's pg_class entry
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 558022647c..d3e6787885 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -22,6 +22,7 @@
 #include "catalog/indexing.h"
 #include "catalog/partition.h"
 #include "catalog/pg_inherits.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_partitioned_table.h"
 #include "nodes/makefuncs.h"
 #include "optimizer/clauses.h"
@@ -29,124 +30,121 @@
 #include "optimizer/var.h"
 #include "partitioning/partbounds.h"
 #include "rewrite/rewriteManip.h"
+#include "storage/lmgr.h"
 #include "utils/fmgroids.h"
 #include "utils/partcache.h"
 #include "utils/rel.h"
 #include "utils/syscache.h"
 
-
-static Oid	get_partition_parent_worker(Relation inhRel, Oid relid);
-static void get_partition_ancestors_worker(Relation inhRel, Oid relid,
-							   List **ancestors);
+static void get_partition_descendants_worker(Oid relid, LOCKMODE lockmode,
+								 List **reloids);
 
 /*
  * get_partition_parent
  *		Obtain direct parent of given relation
  *
- * Returns inheritance parent of a partition by scanning pg_inherits
- *
- * Note: Because this function assumes that the relation whose OID is passed
- * as an argument will have precisely one parent, it should only be called
- * when it is known that the relation is a partition.
+ * Returns partition parent of a partition or InvalidOid if there is no parent
  */
 Oid
 get_partition_parent(Oid relid)
 {
-	Relation	catalogRelation;
 	Oid			result;
+	HeapTuple	tuple;
 
-	catalogRelation = heap_open(InheritsRelationId, AccessShareLock);
-
-	result = get_partition_parent_worker(catalogRelation, relid);
-
-	if (!OidIsValid(result))
-		elog(ERROR, "could not find tuple for parent of relation %u", relid);
+	tuple = SearchSysCache1(RELOID, relid);
+	if (!HeapTupleIsValid(tuple))
+		elog(ERROR, "cache lookup failed for relation %u", relid);
 
-	heap_close(catalogRelation, AccessShareLock);
+	result = ((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent;
+	ReleaseSysCache(tuple);
 
 	return result;
 }
 
 /*
- * get_partition_parent_worker
- *		Scan the pg_inherits relation to return the OID of the parent of the
- *		given relation
+ * get_partition_ancestors
+ *		Obtain ancestors of a given partition or partitioned index.
+ *
+ * Follows pg_class.relpartitionparent links and returns a list of ancestors
+ * of the given partition or partitioned index starting with the parent and
+ * ending with the top-level partitioned table or index.
  */
-static Oid
-get_partition_parent_worker(Relation inhRel, Oid relid)
+List *
+get_partition_ancestors(Oid relid)
 {
-	SysScanDesc scan;
-	ScanKeyData key[2];
-	Oid			result = InvalidOid;
+	List	   *result = NIL;
 	HeapTuple	tuple;
 
-	ScanKeyInit(&key[0],
-				Anum_pg_inherits_inhrelid,
-				BTEqualStrategyNumber, F_OIDEQ,
-				ObjectIdGetDatum(relid));
-	ScanKeyInit(&key[1],
-				Anum_pg_inherits_inhseqno,
-				BTEqualStrategyNumber, F_INT4EQ,
-				Int32GetDatum(1));
-
-	scan = systable_beginscan(inhRel, InheritsRelidSeqnoIndexId, true,
-							  NULL, 2, key);
-	tuple = systable_getnext(scan);
-	if (HeapTupleIsValid(tuple))
+	for (;;)
 	{
-		Form_pg_inherits form = (Form_pg_inherits) GETSTRUCT(tuple);
+		Oid parentOid;
 
-		result = form->inhparent;
-	}
+		tuple = SearchSysCache1(RELOID, relid);
+		if (!HeapTupleIsValid(tuple))
+			elog(ERROR, "cache lookup failed for relation %u", relid);
+
+		parentOid = ((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent;
+		ReleaseSysCache(tuple);
 
-	systable_endscan(scan);
+		if (!OidIsValid(parentOid))
+			break;
+
+		result = lappend_oid(result, parentOid);
+
+		relid = parentOid;
+	}
 
 	return result;
 }
 
 /*
- * get_partition_ancestors
- *		Obtain ancestors of given relation
- *
- * Returns a list of ancestors of the given relation.
- *
- * Note: Because this function assumes that the relation whose OID is passed
- * as an argument and each ancestor will have precisely one parent, it should
- * only be called when it is known that the relation is a partition.
+ * get_partition_descendants
+ *		Returns a list of Oids of all partitions which descend from 'relid'
+ *		including 'relid' itself.  Obtains a 'lockmode' level lock on each
+ *		item in the list.
  */
 List *
-get_partition_ancestors(Oid relid)
+get_partition_descendants(Oid relid, LOCKMODE lockmode)
 {
-	List	   *result = NIL;
-	Relation	inhRel;
-
-	inhRel = heap_open(InheritsRelationId, AccessShareLock);
-
-	get_partition_ancestors_worker(inhRel, relid, &result);
+	List *reloids = NIL;
 
-	heap_close(inhRel, AccessShareLock);
+	get_partition_descendants_worker(relid, lockmode, &reloids);
 
-	return result;
+	return reloids;
 }
 
-/*
- * get_partition_ancestors_worker
- *		recursive worker for get_partition_ancestors
- */
 static void
-get_partition_ancestors_worker(Relation inhRel, Oid relid, List **ancestors)
+get_partition_descendants_worker(Oid relid, LOCKMODE lockmode, List **reloids)
 {
-	Oid			parentOid;
+	Relation rel = relation_open(relid, lockmode);
+	PartitionDesc partdesc;
+	int i;
+
+	partdesc = RelationGetPartitionDesc(rel);
+
+	Assert(partdesc);
 
-	/* Recursion ends at the topmost level, ie., when there's no parent */
-	parentOid = get_partition_parent_worker(inhRel, relid);
-	if (parentOid == InvalidOid)
-		return;
+	*reloids = lappend_oid(*reloids, relid);
 
-	*ancestors = lappend_oid(*ancestors, parentOid);
-	get_partition_ancestors_worker(inhRel, parentOid, ancestors);
+	for (i = 0; i < partdesc->nparts; i++)
+	{
+		Oid partoid = partdesc->oids[i];
+
+		if (!partdesc->is_leaf[i])
+			get_partition_descendants_worker(partoid, lockmode, reloids);
+		else
+		{
+			if (lockmode != NoLock)
+				LockRelationOid(partoid, lockmode);
+
+			*reloids = lappend_oid(*reloids, partoid);
+		}
+	}
+
+	relation_close(rel, NoLock);
 }
 
+
 /*
  * map_partition_varattnos - maps varattno of any Vars in expr from the
  * attno's of 'from_rel' to the attno's of 'to_rel' partition, each of which
diff --git a/src/backend/catalog/pg_inherits.c b/src/backend/catalog/pg_inherits.c
index 85baca54cc..87c8fd3266 100644
--- a/src/backend/catalog/pg_inherits.c
+++ b/src/backend/catalog/pg_inherits.c
@@ -28,6 +28,7 @@
 #include "storage/lmgr.h"
 #include "utils/builtins.h"
 #include "utils/fmgroids.h"
+#include "utils/lsyscache.h" // get_rel_relkind
 #include "utils/memutils.h"
 #include "utils/syscache.h"
 #include "utils/tqual.h"
@@ -172,6 +173,8 @@ find_all_inheritors(Oid parentrelId, LOCKMODE lockmode, List **numparents)
 			   *rel_numparents;
 	ListCell   *l;
 
+	Assert(get_rel_relkind(parentrelId) != RELKIND_PARTITIONED_TABLE);
+
 	memset(&ctl, 0, sizeof(ctl));
 	ctl.keysize = sizeof(Oid);
 	ctl.entrysize = sizeof(SeenRelsEntry);
@@ -267,6 +270,9 @@ has_subclass(Oid relationId)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relationId);
 
+	Assert(!OidIsValid(((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent));
+	Assert(((Form_pg_class) GETSTRUCT(tuple))->relkind != RELKIND_PARTITIONED_TABLE);
+
 	result = ((Form_pg_class) GETSTRUCT(tuple))->relhassubclass;
 	ReleaseSysCache(tuple);
 	return result;
diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index 3e148f03d0..83f70fb165 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -26,6 +26,7 @@
 #include "catalog/catalog.h"
 #include "catalog/index.h"
 #include "catalog/indexing.h"
+#include "catalog/partition.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_namespace.h"
@@ -311,9 +312,10 @@ analyze_rel(Oid relid, RangeVar *relation, int options,
 					   relpages, false, in_outer_xact, elevel);
 
 	/*
-	 * If there are child tables, do recursive ANALYZE.
+	 * If there are child tables or it's a partitioned table, do recursive
+	 * ANALYZE.
 	 */
-	if (onerel->rd_rel->relhassubclass)
+	if (onerel->rd_rel->relhassubclass || onerel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
 		do_analyze_rel(onerel, options, params, va_cols, acquirefunc, relpages,
 					   true, in_outer_xact, elevel);
 
@@ -1334,8 +1336,10 @@ acquire_inherited_sample_rows(Relation onerel, int elevel,
 	 * Find all members of inheritance set.  We only need AccessShareLock on
 	 * the children.
 	 */
-	tableOIDs =
-		find_all_inheritors(RelationGetRelid(onerel), AccessShareLock, NULL);
+	if (onerel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+		tableOIDs = get_partition_descendants(RelationGetRelid(onerel), AccessShareLock);
+	else
+		tableOIDs = find_all_inheritors(RelationGetRelid(onerel), AccessShareLock, NULL);
 
 	/*
 	 * Check that there's at least one descendant, else fail.  This could
diff --git a/src/backend/commands/lockcmds.c b/src/backend/commands/lockcmds.c
index 71278b38cf..4a583c1c8b 100644
--- a/src/backend/commands/lockcmds.c
+++ b/src/backend/commands/lockcmds.c
@@ -15,6 +15,7 @@
 #include "postgres.h"
 
 #include "catalog/namespace.h"
+#include "catalog/partition.h"
 #include "catalog/pg_inherits.h"
 #include "commands/lockcmds.h"
 #include "miscadmin.h"
@@ -29,6 +30,8 @@
 
 static void LockTableRecurse(Oid reloid, LOCKMODE lockmode, bool nowait, Oid userid);
 static AclResult LockTableAclCheck(Oid relid, LOCKMODE lockmode, Oid userid);
+static bool LockSingleTable(Oid relid, LOCKMODE lockmode, bool nowait,
+				Oid userid);
 static void RangeVarCallbackForLockTable(const RangeVar *rv, Oid relid,
 							 Oid oldrelid, void *arg);
 static void LockViewRecurse(Oid reloid, LOCKMODE lockmode, bool nowait, List *ancestor_views);
@@ -107,65 +110,109 @@ RangeVarCallbackForLockTable(const RangeVar *rv, Oid relid, Oid oldrelid,
 }
 
 /*
- * Apply LOCK TABLE recursively over an inheritance tree
+ * LockSingleTable
+ *		Apply LOCK TABLE to a single table.
+ */
+static bool
+LockSingleTable(Oid relid, LOCKMODE lockmode, bool nowait, Oid userid)
+{
+	AclResult	aclresult;
+
+	/* Check permissions before acquiring the lock. */
+	aclresult = LockTableAclCheck(relid, lockmode, userid);
+	if (aclresult != ACLCHECK_OK)
+	{
+		char	   *relname = get_rel_name(relid);
+
+		if (!relname)
+			return false;		/* table concurrently dropped, just skip it */
+		aclcheck_error(aclresult, get_relkind_objtype(get_rel_relkind(relid)), relname);
+	}
+
+	/* We have enough rights to lock the relation; do so. */
+	if (!nowait)
+		LockRelationOid(relid, lockmode);
+	else if (!ConditionalLockRelationOid(relid, lockmode))
+	{
+		/* try to throw error by name; relation could be deleted... */
+		char	   *relname = get_rel_name(relid);
+
+		if (!relname)
+			return false;		/* table concurrently dropped, just skip it */
+		ereport(ERROR,
+				(errcode(ERRCODE_LOCK_NOT_AVAILABLE),
+					errmsg("could not obtain lock on relation \"%s\"",
+						relname)));
+	}
+
+	/*
+	 * Even if we got the lock, child might have been concurrently
+	 * dropped. If so, we can skip it.
+	 */
+	if (!SearchSysCacheExists1(RELOID, ObjectIdGetDatum(relid)))
+	{
+		/* Release useless lock */
+		UnlockRelationOid(relid, lockmode);
+		return false;
+	}
+	return true;
+}
+
+/*
+ * Apply LOCK TABLE recursively over an inheritance tree or partitioned table
  *
  * We use find_inheritance_children not find_all_inheritors to avoid taking
  * locks far in advance of checking privileges.  This means we'll visit
- * multiply-inheriting children more than once, but that's no problem.
+ * multiply-inheriting children more than once, but that's no problem. For
+ * partitions, we simply loop through each partition checking if it's a
+ * sub-partitioned table or leaf partition, for the latter we needn't
+ * recurse, but for the former we must.
  */
 static void
 LockTableRecurse(Oid reloid, LOCKMODE lockmode, bool nowait, Oid userid)
 {
-	List	   *children;
-	ListCell   *lc;
+	Relation rel;
+
+	if (!LockSingleTable(reloid, lockmode, nowait, userid))
+		return;
 
-	children = find_inheritance_children(reloid, NoLock);
+	/* Lock taken above */
+	rel = relation_open(reloid, NoLock);
 
-	foreach(lc, children)
+	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
 	{
-		Oid			childreloid = lfirst_oid(lc);
-		AclResult	aclresult;
+		PartitionDesc partdesc = RelationGetPartitionDesc(rel);
+		int			nparts = partdesc->nparts;
+		int			i;
 
-		/* Check permissions before acquiring the lock. */
-		aclresult = LockTableAclCheck(childreloid, lockmode, userid);
-		if (aclresult != ACLCHECK_OK)
+		for (i = 0; i < nparts; i++)
 		{
-			char	   *relname = get_rel_name(childreloid);
+			Oid partoid = partdesc->oids[i];
 
-			if (!relname)
-				continue;		/* child concurrently dropped, just skip it */
-			aclcheck_error(aclresult, get_relkind_objtype(get_rel_relkind(childreloid)), relname);
+			if (partdesc->is_leaf[i])
+				LockSingleTable(partoid, lockmode, nowait, userid);
+			else
+				LockTableRecurse(partoid, lockmode, nowait, userid);
 		}
+	}
 
-		/* We have enough rights to lock the relation; do so. */
-		if (!nowait)
-			LockRelationOid(childreloid, lockmode);
-		else if (!ConditionalLockRelationOid(childreloid, lockmode))
-		{
-			/* try to throw error by name; relation could be deleted... */
-			char	   *relname = get_rel_name(childreloid);
-
-			if (!relname)
-				continue;		/* child concurrently dropped, just skip it */
-			ereport(ERROR,
-					(errcode(ERRCODE_LOCK_NOT_AVAILABLE),
-					 errmsg("could not obtain lock on relation \"%s\"",
-							relname)));
-		}
+	/* leaf partitions won't have inheritance children, so skip those */
+	else if (!OidIsValid(rel->rd_rel->relpartitionparent))
+	{
+		List	   *children;
+		ListCell   *lc;
 
-		/*
-		 * Even if we got the lock, child might have been concurrently
-		 * dropped. If so, we can skip it.
-		 */
-		if (!SearchSysCacheExists1(RELOID, ObjectIdGetDatum(childreloid)))
+		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+
+		foreach(lc, children)
 		{
-			/* Release useless lock */
-			UnlockRelationOid(childreloid, lockmode);
-			continue;
-		}
+			Oid			childreloid = lfirst_oid(lc);
 
-		LockTableRecurse(childreloid, lockmode, nowait, userid);
+			LockTableRecurse(childreloid, lockmode, nowait, userid);
+		}
 	}
+
+	relation_close(rel, NoLock);
 }
 
 /*
diff --git a/src/backend/commands/publicationcmds.c b/src/backend/commands/publicationcmds.c
index 6f7762a906..4622173e8a 100644
--- a/src/backend/commands/publicationcmds.c
+++ b/src/backend/commands/publicationcmds.c
@@ -28,6 +28,7 @@
 #include "catalog/namespace.h"
 #include "catalog/objectaccess.h"
 #include "catalog/objectaddress.h"
+#include "catalog/partition.h"
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_type.h"
 #include "catalog/pg_publication.h"
@@ -529,8 +530,13 @@ OpenTableList(List *tables)
 			ListCell   *child;
 			List	   *children;
 
-			children = find_all_inheritors(myrelid, ShareUpdateExclusiveLock,
-										   NULL);
+			if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+				children = get_partition_descendants(myrelid,
+													 ShareUpdateExclusiveLock);
+			else
+				children = find_all_inheritors(myrelid,
+											   ShareUpdateExclusiveLock,
+											   NULL);
 
 			foreach(child, children)
 			{
